from xml.sax import make_parser
from xml.sax.handler import ContentHandler
from data import Storm, Node

# Brainstorm application for concept-mapping
# All code copyright activityworkshop.net, see license.txt file

# Class to manage loading of xml files
class StormLoader:
	def loadFile(self, file):
		parser = make_parser()
		handler = StormHandler()
		parser.setContentHandler(handler)
		infile = open(str(file), 'r')
#		try:
		parser.parse(infile)
#		except Exception, detail:
#			print "woah, some exception was thrown: ", detail
			# Note: In later versions of python this except might need an "as"
		# close file
		infile.close()
		# return results
		return handler.storm

# XML handler
class StormHandler(ContentHandler):
	def __init__(self):
		self.storm = Storm()

	def startElement(self, name, attrs):
		self.string = ""
		if name == "node":
			node = Node(None, attrs.get("id",""), attrs.get("label",""), attrs.get("posx",0), attrs.get("posy",0))
			self.storm.addNode(node)
		elif name == "connection":
			self.storm.addEdge(attrs.get("source",""), attrs.get("dest",""))

	def endElement(self, name):
		if name == "title": self.storm.title = self.string
		elif name == "author": self.storm.author = self.string

	def characters (self, ch):
		self.string += ch

